Open CASCADE Technology: TDocStd_Document Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
TDocStd_Document Class Reference

The contents of a TDocStd_Application, a document is a container for a data framework composed of labels and attributes. As such, TDocStd_Document is the entry point into the data framework. To gain access to the data, you create a document as follows: Handle(TDocStd_Document) MyDF = new TDocStd_Document The document also allows you to manage: More...

`#include <TDocStd_Document.hxx>`

Inheritance diagram for TDocStd_Document:
[legend]

## Public Member Functions
| TDocStd_Document (const TCollection_ExtendedString &astorageformat)
| Constructs a document object defined by the string astorageformat. More...
Standard_Boolean | IsSaved () const
| the document is saved in a file. More...
Standard_Boolean | IsChanged () const
| returns True if document differs from the state of last saving. this method have to be called only wroking in the transaction mode More...
void | SetSaved ()
| This method have to be called to show document that it has been saved. More...
void | SetSavedTime (const Standard_Integer theTime)
| Say to document what it is not saved. Use value, returned earlier by GetSavedTime(). More...
Standard_Integer | GetSavedTime () const
| Returns value of <mySavedTime> to be used later in SetSavedTime() More...
TCollection_ExtendedString | GetName () const
| raise if <me> is not saved. More...
TCollection_ExtendedString | GetPath () const
| returns the OS path of the file, in wich one <me> is saved. Raise an exception if <me> is not saved. More...
void | SetData (const Handle< TDF_Data > &data)
Handle< TDF_Data > | GetData () const
TDF_Label | Main () const
| Returns the main label in this data framework. By definition, this is the label with the entry 0:1. More...
Standard_Boolean | IsEmpty () const
| Returns True if the main label has no attributes. More...
Standard_Boolean | IsValid () const
| Returns False if the document has been modified but not recomputed. More...
void | SetModified (const TDF_Label &L)
| Notify the label as modified, the Document becomes UnValid. returns True if <L> has been notified as modified. More...
void | PurgeModified ()
| Remove all modifications. After this call The document becomesagain Valid. More...
const TDF_LabelMap & | GetModified () const
| Returns the labels which have been modified in this document. More...
void | NewCommand ()
| Launches a new command. This command may be undone. More...
Standard_Boolean | HasOpenCommand () const
| returns True if a Command transaction is open in the curret . More...
void | OpenCommand ()
| Opens a new command transaction in this document. You can use HasOpenCommand to see whether a command is already open. Exceptions Standard_DomainError if a command is already open in this document. More...
Standard_Boolean | CommitCommand ()
| Commits documents transactions and fills the transaction manager with documents that have been changed during the transaction. If no command transaction is open, nothing is done. Returns True if a new delta has been added to myUndos. More...
void | AbortCommand ()
| Abort the Command transaction. Does nothing If there is no Command transaction open. More...
Standard_Integer | GetUndoLimit () const
| The current limit on the number of undos. More...
void | SetUndoLimit (const Standard_Integer L)
| Set the limit on the number of Undo Delta stored 0 will disable Undo on the document A negative value means no limit. Note that by default Undo is disabled. Enabling it will take effect with the next call to NewCommand. Of course this limit is the same for Redo. More...
void | ClearUndos ()
| Remove all stored Undos and Redos. More...
void | ClearRedos ()
| Remove all stored Redos. More...
Standard_Integer | GetAvailableUndos () const
| Returns the number of undos stored in this document. If this figure is greater than 0, the method Undo can be used. More...
Standard_Boolean | Undo ()
| Will UNDO one step, returns False if no undo was done (Undos == 0). Otherwise, true is returned and one step in the list of undoes is undone. More...
Standard_Integer | GetAvailableRedos () const
| Returns the number of redos stored in this document. If this figure is greater than 0, the method Redo can be used. More...
Standard_Boolean | Redo ()
| Will REDO one step, returns False if no redo was done (Redos == 0). Otherwise, true is returned, and one step in the list of redoes is done again. More...
const TDF_DeltaList & | GetUndos () const
const TDF_DeltaList & | GetRedos () const
void | RemoveFirstUndo ()
| Removes the first undo in the list of document undos. It is used in the application when the undo limit is exceed. More...
Standard_Boolean | InitDeltaCompaction ()
| Initializes the procedure of delta compaction Returns false if there is no delta to compact Marks the last delta as a "from" delta. More...
Standard_Boolean | PerformDeltaCompaction ()
| Performs the procedure of delta compaction Makes all deltas starting from "from" delta till the last one to be one delta. More...
void | UpdateReferences (const TCollection_AsciiString &aDocEntry)
| Set modifications on labels impacted by external references to the entry. The document becomes invalid and must be recomputed. More...
void | Recompute ()
| Recompute if the document was not valid and propagate the reccorded modification. More...
virtual void | Update (const Handle< CDM_Document > &aToDocument, const Standard_Integer aReferenceIdentifier, const Standard_Address aModifContext)
| This method Update will be called to signal the end of the modified references list. The document should be recomputed and UpdateFromDocuments should be called. Update should returns True in case of success, false otherwise. In case of Failure, additional information can be given in ErrorString. # Update the document by propagation Update the document from internal stored modifications. If you want to undoing this operation, please call NewCommand before. # to change format (advanced programming) More...
virtual TCollection_ExtendedString | StorageFormat () const
| The Storage Format is the key which is used to determine in the application resources the storage driver plugin, the file extension and other data used to store the document. More...
virtual void | ChangeStorageFormat (const TCollection_ExtendedString &newStorageFormat)
| methods for the nested transaction mode More...
void | SetNestedTransactionMode (const Standard_Boolean isAllowed=Standard_True)
| Sets nested transaction mode if isAllowed == Standard_True. More...
Standard_Boolean | IsNestedTransactionMode () const
| Returns Standard_True if mode is set. More...
void | SetModificationMode (const Standard_Boolean theTransactionOnly)
| if theTransactionOnly is True changes is denied outside transactions More...
Standard_Boolean | ModificationMode () const
| returns True if changes allowed only inside transactions More...
virtual void | BeforeClose ()
| Prepares document for closing. More...
Public Member Functions inherited from CDM_Document
virtual Standard_Boolean | Update (TCollection_ExtendedString &ErrorString)
| This method Update will be called to signal the end of the modified references list. The document should be recomputed and UpdateFromDocuments should be called. Update should returns True in case of success, false otherwise. In case of Failure, additional information can be given in ErrorString. More...
virtual void | Extensions (TColStd_SequenceOfExtendedString &Extensions) const
| by default empties the extensions. More...
virtual Standard_Boolean | GetAlternativeDocument (const TCollection_ExtendedString &aFormat, Handle< CDM_Document > &anAlternativeDocument)
| This method can be redefined to extract another document in a different format. For example, to extract a MDTV-Shape from an applicative document. More...
Standard_Integer | CreateReference (const Handle< CDM_Document > &anOtherDocument)
| Creates a reference from this document to {anOtherDocument}. Returns a reference identifier. This reference identifier is unique in the document and will not be used for the next references, even after the storing of the document. If there is already a reference between the two documents, the reference is not created, but its reference identifier is returned. More...
void | RemoveReference (const Standard_Integer aReferenceIdentifier)
| Removes the reference between the From Document and the To Document identified by a reference identifier. More...
void | RemoveAllReferences ()
| Removes all references having this document for From Document. More...
Handle< CDM_Document > | Document (const Standard_Integer aReferenceIdentifier) const
| Returns the To Document of the reference identified by aReferenceIdentifier. If the ToDocument is stored and has not yet been retrieved, this method will retrieve it. More...
Standard_Boolean | IsInSession (const Standard_Integer aReferenceIdentifier) const
| returns True if the To Document of the reference identified by aReferenceIdentifier is in session, False if it corresponds to a not yet retrieved document. More...
Standard_Boolean | IsStored (const Standard_Integer aReferenceIdentifier) const
| returns True if the To Document of the reference identified by aReferenceIdentifier has already been stored, False otherwise. More...
TCollection_ExtendedString | Name (const Standard_Integer aReferenceIdentifier) const
| returns the name of the metadata of the To Document of the reference identified by aReferenceIdentifier. More...
void | UpdateFromDocuments (const Standard_Address aModifContext) const
| call virtual method Update on all referencing documents. This method keeps the list of the – documents to process.It may be the starting of an update – cycle. If not, the reentrant calls made by Update method (without argument) will append the referencing documents to the list and call the Update method (with arguments). Only the first call to UpdateFromDocuments generate call to Update(). More...
Standard_Integer | ToReferencesNumber () const
| returns the number of references having this document as From Document. More...
Standard_Integer | FromReferencesNumber () const
| returns the number of references having this document as To Document. More...
Standard_Boolean | ShallowReferences (const Handle< CDM_Document > &aDocument) const
| returns True is this document references aDocument; More...
Standard_Boolean | DeepReferences (const Handle< CDM_Document > &aDocument) const
| returns True is this document references aDocument; More...
Standard_Integer | CopyReference (const Handle< CDM_Document > &aFromDocument, const Standard_Integer aReferenceIdentifier)
| Copies a reference to this document. This method avoid retrieval of referenced document. The arguments are the original document and a valid reference identifier Returns the local identifier. More...
Standard_Boolean | IsReadOnly () const
| indicates that this document cannot be modified. More...
Standard_Boolean | IsReadOnly (const Standard_Integer aReferenceIdentifier) const
| indicates that the referenced document cannot be modified, More...
void | SetIsReadOnly ()
void | UnsetIsReadOnly ()
void | Modify ()
| Indicates that this document has been modified. This method increments the modification counter. More...
Standard_Integer | Modifications () const
| returns the current modification counter. More...
void | UnModify ()
Standard_Boolean | IsUpToDate (const Standard_Integer aReferenceIdentifier) const
| returns true if the modification counter found in the given reference is equal to the actual modification counter of the To Document. This method is able to deal with a reference to a not retrieved document. More...
void | SetIsUpToDate (const Standard_Integer aReferenceIdentifier)
| Resets the modification counter in the given reference to the actual modification counter of its To Document. This method should be called after the application has updated this document. More...
void | SetComment (const TCollection_ExtendedString &aComment)
| associates a comment with this document. More...
void | AddComment (const TCollection_ExtendedString &aComment)
| appends a comment into comments of this document. More...
void | SetComments (const TColStd_SequenceOfExtendedString &aComments)
| associates a comments with this document. More...
void | Comments (TColStd_SequenceOfExtendedString &aComments) const
| returns the associated comments through <aComments>. Returns empty sequence if no comments are associated. More...
Standard_ExtString | Comment () const
| returns the first of associated comments. By defaut the comment is an empty string. More...
Standard_ExtString | Presentation ()
| Returns an alphanumeric string identifying this document in a unique manner in the current process. The presentation may change when the document is stored. Tries to get the 'FileFormat`.Presentation resource This item is used to give a default presentation to the document. More...
Standard_Boolean | IsStored () const
Standard_Integer | StorageVersion () const
| returns the value of the modification counter at the time of storage. By default returns 0. More...
void | SetMetaData (const Handle< CDM_MetaData > &aMetaData)
| associates database information to a document which has been stored. The name of the document is now the name which has beenused to store the data. More...
void | UnsetIsStored ()
Handle< CDM_MetaData > | MetaData () const
TCollection_ExtendedString | Folder () const
void | SetRequestedFolder (const TCollection_ExtendedString &aFolder)
| defines the folder in which the object should be stored. More...
TCollection_ExtendedString | RequestedFolder () const
Standard_Boolean | HasRequestedFolder () const
void | SetRequestedName (const TCollection_ExtendedString &aName)
| defines the name under which the object should be stored. More...
TCollection_ExtendedString | RequestedName ()
| determines under which the document is going to be store. By default the name of the document wil be – used. If the document has no name its presentation will be used. More...
void | SetRequestedPreviousVersion (const TCollection_ExtendedString &aPreviousVersion)
void | UnsetRequestedPreviousVersion ()
Standard_Boolean | HasRequestedPreviousVersion () const
TCollection_ExtendedString | RequestedPreviousVersion () const
void | SetRequestedComment (const TCollection_ExtendedString &aComment)
| defines the Comment with which the object should be stored. More...
TCollection_ExtendedString | RequestedComment () const
void | LoadResources ()
| read (or rereads) the following resource. More...
Standard_Boolean | FindFileExtension ()
TCollection_ExtendedString | FileExtension ()
| gets the Desktop.Domain.Application.`FileFormat`.FileExtension resource. More...
Standard_Boolean | FindDataType ()
TCollection_ExtendedString | DataType ()
| this datatype will be used if the DBMS deals with this concept gets the `FileFormat`.DataType resource. concept. More...
Standard_Boolean | FindVersionDataType ()
TCollection_ExtendedString | VersionDataType ()
| this datatype will be used if the DBMS deals with this concept gets the `FileFormat`.VersionDataType resource. More...
Standard_Boolean | FindDescription ()
TCollection_ExtendedString | Description ()
| gets the `FileFormat`.Description resource. More...
Standard_Boolean | FindDomain ()
TCollection_ExtendedString | Domain ()
| gets the `FileFormat`.Domain resource. More...
Standard_Boolean | FindStoragePlugin ()
Standard_GUID | StoragePlugin ()
Standard_Boolean | IsModified () const
| returns true if the version is greater than the storage version More...
Standard_OStream & | Print (Standard_OStream &anOStream) const
Standard_OStream & | operator<< (Standard_OStream &anOStream)
Standard_Boolean | IsOpened () const
void | Open (const Handle< CDM_Application > &anApplication)
CDM_CanCloseStatus | CanClose () const
void | Close ()
const Handle< CDM_Application > & | Application () const
virtual Standard_Boolean | CanCloseReference (const Handle< CDM_Document > &aDocument, const Standard_Integer aReferenceIdentifier) const
| A referenced document may indicate through this virtual method that it does not allow the closing of aDocument which it references through the reference aReferenceIdentifier. By default returns Standard_True;;. More...
virtual void | CloseReference (const Handle< CDM_Document > &aDocument, const Standard_Integer aReferenceIdentifier)
| A referenced document may update its internal data structure when {aDocument} which it references through the reference {aReferenceIdentifier} is being closed. By default this method does nothing. More...
Standard_Boolean | IsOpened (const Standard_Integer aReferenceIdentifier) const
| returns true if the document corresponding to the given reference has been retrieved and opened. Otherwise returns false. This method does not retrieve the referenced document More...
void | CreateReference (const Handle< CDM_MetaData > &aMetaData, const Standard_Integer aReferenceIdentifier, const Handle< CDM_Application > &anApplication, const Standard_Integer aToDocumentVersion, const Standard_Boolean UseStorageConfiguration)
Standard_Integer | CreateReference (const Handle< CDM_MetaData > &aMetaData, const Handle< CDM_Application > &anApplication, const Standard_Integer aDocumentVersion, const Standard_Boolean UseStorageConfiguration)
Standard_Integer | ReferenceCounter () const
virtual void | Update ()
| the following method should be used instead: More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual void | Delete () const
| Memory deallocator for transient classes. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Static Public Member Functions
static Handle< TDocStd_Document > | Get (const TDF_Label &L)
| Will Abort any execution, clear fields returns the document which contains <L>. raises an exception if the document is not found. More...
Static Public Member Functions inherited from CDM_Document
static Handle< CDM_Document > | FindFromPresentation (const TCollection_ExtendedString &aPresentation)
| returns the document having the given alphanumeric presentation. More...
static Standard_Boolean | FindPresentation (const TCollection_ExtendedString &aPresentation)
| indicates whether a document having the given presentation does exist. More...

## Protected Member Functions
virtual Standard_Boolean | CommitTransaction ()
| Returns Standard_True done. More...
virtual void | AbortTransaction ()
virtual void | OpenTransaction ()
| methods for protection of changes outside transactions More...
Protected Member Functions inherited from CDM_Document
| CDM_Document ()
virtual void | Destroy ()
| ~CDM_Document ()

## Protected Attributes
TCollection_ExtendedString | myStorageFormat
TDF_DeltaList | myUndos
TDF_DeltaList | myRedos
Protected Attributes inherited from CDM_Document
Standard_Boolean | myResourcesAreLoaded

## Detailed Description

The contents of a TDocStd_Application, a document is a container for a data framework composed of labels and attributes. As such, TDocStd_Document is the entry point into the data framework. To gain access to the data, you create a document as follows: Handle(TDocStd_Document) MyDF = new TDocStd_Document The document also allows you to manage:

- modifications, providing Undo and Redo functions.
- command transactions. Warning: The only data saved is the framework (TDF_Data)

## Constructor & Destructor Documentation

TDocStd_Document::TDocStd_Document | ( | const TCollection_ExtendedString & | astorageformat | ) |

Constructs a document object defined by the string astorageformat.

## Member Function Documentation

void TDocStd_Document::AbortCommand | ( |  | ) |

Abort the Command transaction. Does nothing If there is no Command transaction open.

virtual void TDocStd_Document::AbortTransaction | ( |  | ) |
| protectedvirtual

virtual void TDocStd_Document::BeforeClose | ( |  | ) |
| virtual

Prepares document for closing.

virtual void TDocStd_Document::ChangeStorageFormat | ( | const TCollection_ExtendedString & | newStorageFormat | ) |
| virtual

methods for the nested transaction mode

void TDocStd_Document::ClearRedos | ( |  | ) |

Remove all stored Redos.

void TDocStd_Document::ClearUndos | ( |  | ) |

Remove all stored Undos and Redos.

Standard_Boolean TDocStd_Document::CommitCommand | ( |  | ) |

Commits documents transactions and fills the transaction manager with documents that have been changed during the transaction. If no command transaction is open, nothing is done. Returns True if a new delta has been added to myUndos.

virtual Standard_Boolean TDocStd_Document::CommitTransaction | ( |  | ) |
| protectedvirtual

Returns Standard_True done.

static Handle< TDocStd_Document > TDocStd_Document::Get | ( | const TDF_Label & | L | ) |
| static

Will Abort any execution, clear fields returns the document which contains <L>. raises an exception if the document is not found.

Standard_Integer TDocStd_Document::GetAvailableRedos | ( |  | ) | const

Returns the number of redos stored in this document. If this figure is greater than 0, the method Redo can be used.

Standard_Integer TDocStd_Document::GetAvailableUndos | ( |  | ) | const

Returns the number of undos stored in this document. If this figure is greater than 0, the method Undo can be used.

Handle< TDF_Data > TDocStd_Document::GetData | ( |  | ) | const

const TDF_LabelMap& TDocStd_Document::GetModified | ( |  | ) | const

Returns the labels which have been modified in this document.

TCollection_ExtendedString TDocStd_Document::GetName | ( |  | ) | const

raise if <me> is not saved.

TCollection_ExtendedString TDocStd_Document::GetPath | ( |  | ) | const

returns the OS path of the file, in wich one <me> is saved. Raise an exception if <me> is not saved.

const TDF_DeltaList& TDocStd_Document::GetRedos | ( |  | ) | const

Standard_Integer TDocStd_Document::GetSavedTime | ( |  | ) | const

Returns value of <mySavedTime> to be used later in SetSavedTime()

Standard_Integer TDocStd_Document::GetUndoLimit | ( |  | ) | const

The current limit on the number of undos.

const TDF_DeltaList& TDocStd_Document::GetUndos | ( |  | ) | const

Standard_Boolean TDocStd_Document::HasOpenCommand | ( |  | ) | const

returns True if a Command transaction is open in the curret .

Standard_Boolean TDocStd_Document::InitDeltaCompaction | ( |  | ) |

Initializes the procedure of delta compaction Returns false if there is no delta to compact Marks the last delta as a "from" delta.

Standard_Boolean TDocStd_Document::IsChanged | ( |  | ) | const

returns True if document differs from the state of last saving. this method have to be called only wroking in the transaction mode

Standard_Boolean TDocStd_Document::IsEmpty | ( |  | ) | const

Returns True if the main label has no attributes.

Standard_Boolean TDocStd_Document::IsNestedTransactionMode | ( |  | ) | const

Returns Standard_True if mode is set.

Standard_Boolean TDocStd_Document::IsSaved | ( |  | ) | const

the document is saved in a file.

Standard_Boolean TDocStd_Document::IsValid | ( |  | ) | const

Returns False if the document has been modified but not recomputed.

TDF_Label TDocStd_Document::Main | ( |  | ) | const

Returns the main label in this data framework. By definition, this is the label with the entry 0:1.

Standard_Boolean TDocStd_Document::ModificationMode | ( |  | ) | const

returns True if changes allowed only inside transactions

void TDocStd_Document::NewCommand | ( |  | ) |

Launches a new command. This command may be undone.

void TDocStd_Document::OpenCommand | ( |  | ) |

Opens a new command transaction in this document. You can use HasOpenCommand to see whether a command is already open. Exceptions Standard_DomainError if a command is already open in this document.

virtual void TDocStd_Document::OpenTransaction | ( |  | ) |
| protectedvirtual

methods for protection of changes outside transactions

Standard_Boolean TDocStd_Document::PerformDeltaCompaction | ( |  | ) |

Performs the procedure of delta compaction Makes all deltas starting from "from" delta till the last one to be one delta.

void TDocStd_Document::PurgeModified | ( |  | ) |

Remove all modifications. After this call The document becomesagain Valid.

void TDocStd_Document::Recompute | ( |  | ) |

Recompute if the document was not valid and propagate the reccorded modification.

Standard_Boolean TDocStd_Document::Redo | ( |  | ) |

Will REDO one step, returns False if no redo was done (Redos == 0). Otherwise, true is returned, and one step in the list of redoes is done again.

void TDocStd_Document::RemoveFirstUndo | ( |  | ) |

Removes the first undo in the list of document undos. It is used in the application when the undo limit is exceed.

void TDocStd_Document::SetData | ( | const Handle< TDF_Data > & | data | ) |

void TDocStd_Document::SetModificationMode | ( | const Standard_Boolean | theTransactionOnly | ) |

if theTransactionOnly is True changes is denied outside transactions

void TDocStd_Document::SetModified | ( | const TDF_Label & | L | ) |

Notify the label as modified, the Document becomes UnValid. returns True if <L> has been notified as modified.

void TDocStd_Document::SetNestedTransactionMode | ( | const Standard_Boolean | isAllowed = `Standard_True` | ) |

Sets nested transaction mode if isAllowed == Standard_True.

void TDocStd_Document::SetSaved | ( |  | ) |

This method have to be called to show document that it has been saved.

void TDocStd_Document::SetSavedTime | ( | const Standard_Integer | theTime | ) |

Say to document what it is not saved. Use value, returned earlier by GetSavedTime().

void TDocStd_Document::SetUndoLimit | ( | const Standard_Integer | L | ) |

Set the limit on the number of Undo Delta stored 0 will disable Undo on the document A negative value means no limit. Note that by default Undo is disabled. Enabling it will take effect with the next call to NewCommand. Of course this limit is the same for Redo.

virtual TCollection_ExtendedString TDocStd_Document::StorageFormat | ( |  | ) | const
| virtual

The Storage Format is the key which is used to determine in the application resources the storage driver plugin, the file extension and other data used to store the document.

Implements CDM_Document.

Standard_Boolean TDocStd_Document::Undo | ( |  | ) |

Will UNDO one step, returns False if no undo was done (Undos == 0). Otherwise, true is returned and one step in the list of undoes is undone.

virtual void TDocStd_Document::Update | ( | const Handle< CDM_Document > & | aToDocument,
|  | const Standard_Integer | aReferenceIdentifier,
|  | const Standard_Address | aModifContext
| ) |  |
| virtual

This method Update will be called to signal the end of the modified references list. The document should be recomputed and UpdateFromDocuments should be called. Update should returns True in case of success, false otherwise. In case of Failure, additional information can be given in ErrorString.

# Update the document by propagation

Update the document from internal stored modifications. If you want to undoing this operation, please call NewCommand before.

# to change format (advanced programming)

Reimplemented from CDM_Document.

void TDocStd_Document::UpdateReferences | ( | const TCollection_AsciiString & | aDocEntry | ) |

Set modifications on labels impacted by external references to the entry. The document becomes invalid and must be recomputed.

## Field Documentation

TDF_DeltaList TDocStd_Document::myRedos
| protected

TCollection_ExtendedString TDocStd_Document::myStorageFormat
| protected

TDF_DeltaList TDocStd_Document::myUndos
| protected

The documentation for this class was generated from the following file:

- TDocStd_Document.hxx